/*
    <Interfaz Grafica>
    Copyright (C) <2011>  <José Antonio Sánchez Reynaga>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef WINDOW_H
#define WINDOW_H

#include <QtCore>
#include <QtGui>
#include "devices.h"
#include "threadformat.h"

namespace Ui {
    class Window;
}

class Window : public QWidget
{
    Q_OBJECT

public:
    explicit Window(QWidget *parent = 0);
    ~Window();
    
    void setDevice(Device dev);
    Ui::Window* getUi();

    
public slots:
    /**
     * Refresca la lista de dispositivos 
     * disponibles para dar formato
     */
    void refreshListDevices();
    
    /**
     * Refresca los datos del dispositivos
     */
    void refreshDeviceProperties();
 
    /**
     * Aplicar formato al dispositivo
     */
    void applyFormat();
    
    /**
     * Metodo que se ejecuta que cuando termina la ejecucion del hilo
     */
    void checkFormat();
    
    void enableGUI();
    void disableGUI();

private:
    Ui::Window *ui;
    Device actual;  //Dispositivo que esta seleccionado
    ThreadFormat *threadFormat; //Hilo para la ejecucion de comandos para el formato
};

#endif // WINDOW_H
